﻿using System;
using System.Collections.Generic;
using NUnit.Framework;
using OpenQA.Selenium.Chrome;
using Selenium.Examples.Performance;

namespace Selenium.Examples
{
    public class Tests
    {
        private ChromeDriver _driver;

        [SetUp]
        public void Setup()
        {
            _driver = new ChromeDriver();
            _driver.Manage().Timeouts().ImplicitlyWait(new TimeSpan(0, 0, 30));
        }

        [Test]
        public void GetPageLoadTime()
        {
            _driver.Navigate()
                .GoToUrl("http://www.deanhume.com/home/about");

            // Get the webTimings for our performance measurements
            Dictionary<string, object> webTimings =
                _driver.WebTimings();

            if (webTimings.Count == 0)
            {
                Assert.Fail();
            }
        }

        #region TearDown

        [TearDown]
        public void FixtureTearDown()
        {
            if (_driver != null) _driver.Close();
        }

        #endregion
    }
}
